# Version 4.0.1
# TODO rust version as var
# TODO caching build dependencies between jobs (this wastes most of the CI time)
stages:
  - build
  - test
  # - release

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_PIPELINE_SOURCE == "push"
    - if: $CI_PIPELINE_SOURCE == "web"

variables:
  CI_DEBUG_SERVICES: "true"
  FF_NETWORK_PER_BUILD: "true"
  APP_NAME: book-list
  E2E_DOCKER_URL: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}_${CI_PIPELINE_ID}
  POSTGRES_PASSWORD: 2vQU45haQCnDS8sO
  POSTGRES_USER: book-list
  POSTGRES_DB: book-list

include:
  - project: 'mobica-workshops/templates/ci/gitlab-ci'
    file:
      - '.ansible-ci-template.yml'
      - '.docker-ci-template.yml'
      - '.rust-ci-template.yml'
      - '.e2e_test_ci_template.yml'

configure:
  stage: .pre
  extends: .ansible_create_configuration_job_definition

lint:
  image: rust:1.67-bullseye
  stage: test
  dependencies:
    - configure
  script:
    - | # Custom image should also be used here
      rustup component add rustfmt
      rustup component add clippy
    - cargo fmt --check
    - cargo clippy

docker_build_commit:
  variables:
    DOCKER_FILE: multi-stage.Dockerfile
    CONTAINER_IMAGE: $E2E_DOCKER_URL
  stage: build
  extends: .gitlab_docker_build_job_definition_kaniko
  needs:
    - configure
  after_script:
    # If we try to pull the image immediately it sometimes fails
    - sleep 5

docker_release_latest:
  stage: build
  variables:
    CONTAINER_IMAGE: $CI_REGISTRY_IMAGE:latest
    DOCKER_FILE: multi-stage.Dockerfile
  extends: .gitlab_docker_build_job_definition_kaniko
  dependencies:
    - configure
  only:
    - master
  when: manual

docker_release_tag:
  stage: build
  variables:
    DOCKER_FILE: multi-stage.Dockerfile
  extends: .gitlab_docker_build_job_definition_kaniko
  dependencies:
    - configure
  only:
    - tag

package:
  stage: build
  extends: .rust_build_job_definition

unit_test:
  image: rust:1.67-bullseye
  services:
    - name: postgres:14-alpine
      alias: book-list-db
  stage: test
  script:
    # In a real project custom image with rust and docker should be made insted of installing these each time
    - ./test.sh

.e2e_test_go_job_definition:
  extends: .e2e_test_job_definition
  variables:
    TESTED_SERVICE: "book_list"
  services:
    - name: postgres:14-alpine
      alias: book-list-db
    - name: $E2E_DOCKER_URL
      alias: book-list
      variables:
        HEALTHCHECK_TCP_PORT: "8080"
      entrypoint:
        - '/bin/sh'
        - '-c'
        - |
          # Wait some time to allow for full database initialization
          # This would benefit from some better synchro than sleep
          echo "something"
          sleep 60
          /bin/book-list "$@"
        - '--'
      command: ["--config", "/builds/mobica-workshops/examples/rust/axum/book-list/secrets/ci.env.yaml",
        "serve", "--bind", "0.0.0.0", "--port", "8080", "--migrate", "--load", "--cors"]
  needs:
    - docker_build_commit
    - configure
  stage: test

e2e_test:
  extends: .e2e_test_go_job_definition
  except:
    - merge_requests
    - tag

e2e_test_with_benchmark:
  extends: .e2e_test_go_job_definition
  variables:
    BENCHMARK: "true"
  only:
    - tag
    - merge_requests
  artifacts:
    expire_in: 1 week
    paths:
      - "benchmark*.svg"

remove_docker_commit_image:
  extends: .gitlab_docker_delete_image_job_definition
  variables:
    IMAGE_TAG: $E2E_DOCKER_URL
  stage: .post
  when: always
